// Code generated by go-swagger; DO NOT EDIT.

package roles

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"errors"
	"net/url"
	golangswaggerpaths "path"

	"github.com/go-openapi/swag"
)

// UserRoleListURL generates an URL for the user role list operation
type UserRoleListURL struct {
	Limit *int64
	Names []string
	Order *int64
	Skip  *int64
	Sort  *string

	_basePath string
	// avoid unkeyed usage
	_ struct{}
}

// WithBasePath sets the base path for this url builder, only required when it's different from the
// base path specified in the swagger spec.
// When the value of the base path is an empty string
func (o *UserRoleListURL) WithBasePath(bp string) *UserRoleListURL {
	o.SetBasePath(bp)
	return o
}

// SetBasePath sets the base path for this url builder, only required when it's different from the
// base path specified in the swagger spec.
// When the value of the base path is an empty string
func (o *UserRoleListURL) SetBasePath(bp string) {
	o._basePath = bp
}

// Build a url path and query string
func (o *UserRoleListURL) Build() (*url.URL, error) {
	var _result url.URL

	var _path = "/api/roles"

	_basePath := o._basePath
	_result.Path = golangswaggerpaths.Join(_basePath, _path)

	qs := make(url.Values)

	var limitQ string
	if o.Limit != nil {
		limitQ = swag.FormatInt64(*o.Limit)
	}
	if limitQ != "" {
		qs.Set("limit", limitQ)
	}

	var namesIR []string
	for _, namesI := range o.Names {
		namesIS := namesI
		if namesIS != "" {
			namesIR = append(namesIR, namesIS)
		}
	}

	names := swag.JoinByFormat(namesIR, "")

	if len(names) > 0 {
		qsv := names[0]
		if qsv != "" {
			qs.Set("names", qsv)
		}
	}

	var orderQ string
	if o.Order != nil {
		orderQ = swag.FormatInt64(*o.Order)
	}
	if orderQ != "" {
		qs.Set("order", orderQ)
	}

	var skipQ string
	if o.Skip != nil {
		skipQ = swag.FormatInt64(*o.Skip)
	}
	if skipQ != "" {
		qs.Set("skip", skipQ)
	}

	var sortQ string
	if o.Sort != nil {
		sortQ = *o.Sort
	}
	if sortQ != "" {
		qs.Set("sort", sortQ)
	}

	_result.RawQuery = qs.Encode()

	return &_result, nil
}

// Must is a helper function to panic when the url builder returns an error
func (o *UserRoleListURL) Must(u *url.URL, err error) *url.URL {
	if err != nil {
		panic(err)
	}
	if u == nil {
		panic("url can't be nil")
	}
	return u
}

// String returns the string representation of the path with query string
func (o *UserRoleListURL) String() string {
	return o.Must(o.Build()).String()
}

// BuildFull builds a full url with scheme, host, path and query string
func (o *UserRoleListURL) BuildFull(scheme, host string) (*url.URL, error) {
	if scheme == "" {
		return nil, errors.New("scheme is required for a full url on UserRoleListURL")
	}
	if host == "" {
		return nil, errors.New("host is required for a full url on UserRoleListURL")
	}

	base, err := o.Build()
	if err != nil {
		return nil, err
	}

	base.Scheme = scheme
	base.Host = host
	return base, nil
}

// StringFull returns the string representation of a complete url
func (o *UserRoleListURL) StringFull(scheme, host string) string {
	return o.Must(o.BuildFull(scheme, host)).String()
}
